#!/usr/local/bin/perl
# photometry.pl 
# Created: Yoshifusa Ita, 06-Aug-28

if(@ARGV < 2){
    die "Usage: photometry.pl *.mag.dat *.all.dat\n";
}

# aperture$BB,8w$N7k2L(B
$fname = shift(@ARGV);
open(IN, $fname) || die "$ARGV[0] : $!";
$i = 0;
while(<IN>){
    chomp;
    if($_ !~ /^#/){
	$a1[$i] = $_;
	($x1[$i], $y1[$i], $m1[$i], $e1[$i])=(split(/\s+/, $_))[1,2,11,12];
#    print( "$x1[$i] $y1[$i]\n" );
	$i += 1;
    }
}
close(IN);

# $B8IN)@1(B($BH>7B(B10pix$B0JFb$K@1$,$J$$$+(B)$B$+$I$&$+D4$Y$k(B
$n1 = @x1;
for($i=0;$i<$n1;$i+=1){
    $proximity1[$i] = 0;
    for($j=0;$j<$n1;$j+=1){
	$dx = $x1[$i] - $x1[$j];
	$dy = $y1[$i] - $y1[$j];
	$r = sqrt($dx*$dx + $dy*$dy);
	if($r<10.0&&$r>1.0){
	    $proximity1[$i] += 1;
	}
    }
}

# psf fit$BB,8w$N7k2L(B
$fname = shift(@ARGV);
open(IN, $fname) || die "$ARGV[0] : $!";
$i = 0;
while(<IN>){
    chomp;
    if($_ !~ /^#/){
	$a2[$i] = $_;
	($x2[$i], $y2[$i], $m2[$i], $e2[$i])=(split(/\s+/, $_))[1,2,5,6];
#    print( "$x2[$i] $y2[$i]\n" );
	$i += 1;
    }
}
close(IN);

# $B8IN)@1(B($BH>7B(B10pix$B0JFb$K@1$,$J$$$+(B)$B$+$I$&$+D4$Y$k(B
$n2 = @x2;
for($i=0;$i<$n2;$i+=1){
    $proximity2[$i] = 0;
    for($j=0;$j<$n2;$j+=1){
	$dx = $x2[$i] - $x2[$j];
	$dy = $y2[$i] - $y2[$j];
	$r = sqrt($dx*$dx + $dy*$dy);
	if($r<10.0&&$r>1.0){
	    $proximity2[$i] += 1;
	}
    }
}


for($i=0;$i<$n1;$i+=1){
    for($j=0;$j<$n2;$j+=1){
	$dx = $x1[$i] - $x2[$j];
	$dy = $y1[$i] - $y2[$j];
	$r = sqrt($dx*$dx + $dy*$dy);
	if($r<0.01){
	    if($m1[$i] != INDEF && $m2[$j] != INDEF  && $e1[$i] < 0.5 && $e2[$j] < 0.5 && $proximity1[$i] < 2 && $proximity2[$j] < 2){
		$dm = $m1[$i] - $m2[$j]; # AP mag - Fit mag
		print("$m1[$i] $m2[$j] $dm\n");
#		print("$x1[$i] $y1[$i]\n");
	    }
	}
    }
}
