#!/usr/local/bin/perl
# get2mass.pl -- To retrieve 2mass all sky survey catalog data 
#                from the VizieR upon request
# Usage: get2mass.pl 05:25:33.4 -69:19:30.0 10.0
# Created: Yoshifusa Ita, 19-Dec-05

if(@ARGV < 3){
    die "Usage: get2mass.pl 12.34 -12.34 10.0\n";
}

$ra  = $ARGV[0]; # ra  [degree]
chomp $ra;
$dec = $ARGV[1]; # dec [degree]
chomp $dec;
$box = $ARGV[2]; # box [arcmin]
chomp $box;

# printf("%s %s %s\n",$ra,$dec,$box);

# Strasbourg, France 
#$url = "\"http://vizier.u-strasbg.fr/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# Tokyo Japan
$url = "\"http://vizier.nao.ac.jp/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# Canada
#$url = "\"http://vizier.hia.nrc.ca/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# UK, Cambridge
#$url = "\"http://vizier.ast.cam.ac.uk/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# India, Pune
#$url = "\"http://vizier.iucaa.ernet.in/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# China
#$url = "\"http://data.bao.ac.cn/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# Harvard, USA
#$url = "\"http://vizier.cfa.harvard.edu/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";
# Hawaii, USA
#$url = "\"http://vizier.ukirt.jach.hawaii.edu/viz-bin/asu-acl?-source=2MASS&-c.ra=${ra}&-c.dec=${dec}&-c.bm=$box&-out.max=99999\"";


#printf("%s\n",$url);

print "Now retrieving and downloading 2mass catalog data\n";
system("curl -# -o 2mass.out -O $url");
print "\n";

