#!/usr/local/bin/perl
# selectPSF.pl 
# Created: Yoshifusa Ita, 06-Aug-28

if(@ARGV < 5){
    die "Usage: selectPSF.pl *.pst.dat 2000 10\n";
}

$fname = $ARGV[0];
open(IN, $fname) || die "$ARGV[0] : $!";
$skyval = $ARGV[1];
chomp $skyval;
$skysig = $ARGV[2];
chomp $skysig;
$blimit = $ARGV[3];
chomp $blimit;
$flimit = $ARGV[4];
chomp $flimit;

$sigma=2.0;

while(<IN>){
    chomp;
    if($_ !~ /^\#/){
	($mag, $sky) = (split(/\s+/,$_))[3,4];
	if($mag > $blimit && $mag < $flimit && $sky > 0.0 && $sky > $skyval - $sigma*$skysig && $sky < $skyval + $sigma*$skysig){
	    print($_,"\n");
	}
    }else{
	print($_,"\n");
    }
}

close(IN);
